#!/usr/bin/perl
# $Id: JConv.pl,v 1.4 2001/06/13 17:40:49 will Exp $

use Getopt::Long;
use Jcode;

my (%opt) = ();
GetOptions(\%opt, "to=s", "from:s");

if (!$opt{'to'}) {
    die "Must have --to";
}

$jcode = Jcode->new();

while (<>) {
    chomp;
    if ($opt{'from'}) {
	$jcode->set($_, $opt{'from'});
    } else {
	$jcode->set($_);
    }
    print doConversion($jcode, $opt{'to'});
}

sub doConversion($jcode, $to) {
    my($jcode) = shift;
    my($to) = shift;
    
    if ($to eq "sjis") {
	$ret = $jcode->sjis;
    } elsif ($to eq "jis") {
	$ret = $jcode->jis;
    } elsif ($to eq "unicode") {
	$ret = $jcode->ucs2;
    } elsif ($to eq "utf8") {
	$ret = $jcode->utf8;
    } elsif ($to eq "euc") {
	$ret = $jcode->euc;
    } elsif ($to eq "ascii") {
	$ret = $jcode->euc;
    } elsif ($to eq "binary") {
	$ret = $jcode->binary;
    } elsif ($to eq "iso-2022-jp") {
	$ret = $jcode->iso_2022_jp;
    } 
    return $ret;
}
