<?
class EncodingConv {
  var $stringVal;
  var $encoding;
  var $lang;
  var $japanese_converter = "/usr/sausalito/perl/JConv.pl";
  
  function EncodingConv($string, $lang, $encoding = "") {
    $this->stringVal = $string;
    $this->lang = $lang;
    $this->encoding = $encoding;
  }

  function doJapanese($oldString, $newEncoding, $oldEncoding = "") {
		// we trust jstring to tell us the correct encoding
		if(!$oldEncoding)
			$oldEncoding = mb_detect_encoding($oldString);

		// but we don't trust jstring to do the conversion because it can't
		// handle SJIS
		// We use i18n_convert here, which is an undocumented function
		// that Shibuya found somewhere. The documented iconv_convert
		// that we previously used doesn't support some extensions to
		// certain character encodings (IBM codes in JIS)
  		return mb_convert_encoding($oldString, $newEncoding, $oldEncoding);
  }

  function toSJIS() {
    if ($this->lang != "japanese") 
      return 0;
    
    return $this->doJapanese($this->stringVal, "sjis", $this->encoding);
  }

  function toUnicode() {
    if ($this->lang != "japanese") 
      return 0;
    return $this->doJapanese($this->stringVal, "unicode", $this->encoding);
  }

  function toUTF8() {
    if ($this->lang != "japanese") 
      return 0;
    return $this->doJapanese($this->stringVal, "utf8",  $this->encoding);
  }

  function toJIS() {
    if ($this->lang != "japanese") 
      return 0;
    return $this->doJapanese($this->stringVal, "jis", $this->encoding);
  }

  function toEUC() {
    if ($this->lang != "japanese") 
      return 0;
    return $this->doJapanese($this->stringVal, "euc",  $this->encoding);
  }    

  function toISO2022() {
    if ($this->lang != "japanese") 
      return 0;
    return $this->doJapanese($this->stringVal, "iso-2022-jp",  $this->encoding);
  }
}
?>
